SET TERM ^ ;

create or alter procedure UTPR_SPLIT (
    SSOURCE DM_BLOBTEXT,
    SEPARATOR DM_TEXT)
returns (
    ITEM DM_TEXT)
as
declare variable I integer;
declare variable LSEP integer;
begin
  i=position(separator,ssource);
  lsep=char_length(separator);
  while (i>0) do
  begin
    item=substring(ssource from 1 for i-1);
    suspend;
    ssource=substring(ssource from i+lsep for char_length(ssource));
    i=position(separator,ssource);
  end 
  item=ssource;
  suspend;
end^

SET TERM ; ^

/* Existing privileges on this procedure */

GRANT EXECUTE ON PROCEDURE UTPR_SPLIT TO PROCEDURE PR_DP_GETNAME_RULE;
GRANT EXECUTE ON PROCEDURE UTPR_SPLIT TO SYSDBA;



INSERT INTO GROUPS (ID, PARENT_ID, CAPTION, GROUPTABLE, STATUS, INSERTDT, SYSTEMFLAG, DESCRIPTION, IMAGEINDEX, COLOR, SORTING, BASE_AGENT_ID, SID)
            VALUES (-805, 32, '  - ', 'TMS                            ', 0, '2018-09-07 16:18:40', 0, NULL, -1, NULL, NULL, 0, 'TMS_DP_LOCAL_DETAIL            ');
INSERT INTO GROUPS (ID, PARENT_ID, CAPTION, GROUPTABLE, STATUS, INSERTDT, SYSTEMFLAG, DESCRIPTION, IMAGEINDEX, COLOR, SORTING, BASE_AGENT_ID, SID)
            VALUES (-804, -400, ' ', 'TMS                            ', 0, '2018-09-07 16:18:40', 0, NULL, -1, NULL, NULL, 0, 'TMS_DP_LOCAL                   ');
INSERT INTO GROUPS (ID, PARENT_ID, CAPTION, GROUPTABLE, STATUS, INSERTDT, SYSTEMFLAG, DESCRIPTION, IMAGEINDEX, COLOR, SORTING, BASE_AGENT_ID, SID)
            VALUES (-803, 32, '  -  ', 'TMS                            ', 0, '2018-09-07 16:20:04', 0, NULL, -1, NULL, NULL, 0, 'TMS_DP_LOCAL_NAME_RULE         ');
INSERT INTO GROUPS (ID, PARENT_ID, CAPTION, GROUPTABLE, STATUS, INSERTDT, SYSTEMFLAG, DESCRIPTION, IMAGEINDEX, COLOR, SORTING, BASE_AGENT_ID, SID)
            VALUES (-802, -400, '', 'TMS                            ', 0, '2018-09-07 16:20:04', 0, NULL, -1, NULL, NULL, 0, 'DP_MAIN                        ');
INSERT INTO GROUPS (ID, PARENT_ID, CAPTION, GROUPTABLE, STATUS, INSERTDT, SYSTEMFLAG, DESCRIPTION, IMAGEINDEX, COLOR, SORTING, BASE_AGENT_ID, SID)
            VALUES (-801, 61, '  ', 'TMS                            ', 0, '2018-09-10 16:33:28', 0, NULL, -1, NULL, NULL, 0, NULL);
INSERT INTO GROUPS (ID, PARENT_ID, CAPTION, GROUPTABLE, STATUS, INSERTDT, SYSTEMFLAG, DESCRIPTION, IMAGEINDEX, COLOR, SORTING, BASE_AGENT_ID, SID)
            VALUES (-800, 61, ' ', 'TMS                            ', 0, '2018-09-10 16:19:20', 0, NULL, -1, NULL, NULL, 0, NULL);

COMMIT WORK;



INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, ' ', ' ', 'DP_LMAIN                       ', 2, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]
delete from DP_LRATING where dhash in (:SELECTED_IDS:)

[deletesql]
delete from DP_LRATING where dhash=:dhash

[refreshsql]

[selectsqlwithdeleted]

[selectsql]
select dhash, min(sname) as sname, count(1) as cnt,
max(POSITION_UUID) as POSITION_UUID,max(PART_ID) as PART_ID,max(WARE_ID) as WARE_ID,max(BARCODE) as BARCODE,max(NAME_ID) as NAME_ID,max(GROUP_ID) as GROUP_ID, max(NAME_RULE) as NAME_RULE
from DP_LRATING group by dhash order by 2

[main]
sourcetablename=DP_LRATING
returnfieldname=dhash
captionfieldname=SNAME
keyfieldname=dhash
ViewID=DP_LRATING_CUT
RootGroupTableName=
ShowCaption=
GetCaption=
GroupSelect=0
foldergroup=
initfolder_id=
dataset=1
InitTMSGroup_id=-804
folders_visible=0
Canfloating=0
hidetoppanel=0
ActivateDictAction=0

[cfSelect]
selectfieldexpression=SNAME
AllwaysPartial=1

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=1
bottomdock_size=50
rightdock_units=1
rightdock_size=0

[child_1]
caption=  
wdict=DP_LDETAIL
oninit=tek_id=dhash
afterscroll=tek_id=dhash
afterupd=tek_id=dhash
defaultdocksite=bottom
ShortCut=

', 3, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, '', NULL, 'DP_MAIN                        ', 1, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]

[deletesql]

[refreshsql]
select * from DP_RATING_CUT where barcode=:barcode

[selectsqlwithdeleted]

[selectsql]
select * from DP_RATING_CUT order by sname

[main]
sourcetablename=DP_RATING_CUT
returnfieldname=BARCODE
captionfieldname=SNAME
keyfieldname=BARCODE
ViewID=dp_main
RootGroupTableName=
ShowCaption=
GetCaption=
GroupSelect=0
foldergroup=
initfolder_id=
dataset=1
InitTMSGroup_id=-802
folders_visible=0
Canfloating=0
hidetoppanel=0
ActivateDictAction=0
folderscaption=

[cfSelect]
selectfieldexpression=SNAME||barcode
AllwaysPartial=1

[block_hl]
fieldname=
column=
color1=128
color2=32768

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=0
bottomdock_size=0
rightdock_units=1
rightdock_size=50

[~child_1]
caption= 
wdict=DP_DETAIL
oninit=tek=barcode
afterscroll=tek=barcode
afterupd=
afterdatasetopen=tek=sname
defaultdocksite=right
ShortCut=

[~child_2]
caption= 
wdict=DP_BC_CHECK
oninit=tek=barcode
afterscroll=tek=barcode
afterupd=
afterdatasetopen=tek=sname
defaultdocksite=bottom
ShortCut=', NULL, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, '  - ', '  - ', 'DP_LDETAIL                     ', 1, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]
delete from dp_lrating where id in (:SELECTED_IDS:)

[deletesql]
delete from dp_lrating where id=:id

[refreshsql]
select * from dp_lrating where id=:id

[selectsqlwithdeleted]

[selectsql]
select * from dp_lrating where dhash=:tek_id and CO_NAME_RULE is not null order by cnt desc

[main]
sourcetablename=DP_LRATING
returnfieldname=ID
captionfieldname=SNAME
keyfieldname=ID
ViewID=DP_LRATING
RootGroupTableName=
ShowCaption= 
GetCaption= 
GroupSelect=0
foldergroup=
initfolder_id=
dataset=0
InitTMSGroup_id=-805
folders_visible=0
Canfloating=0
hidetoppanel=0
ActivateDictAction=0

[cfSelect]
selectfieldexpression=SNAME
AllwaysPartial=1

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=0
bottomdock_size=0
rightdock_units=0
rightdock_size=0

', NULL, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, ' ', NULL, 'DP_DETAIL                      ', 1, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]

[deletesql]

[refreshsql]
select * from dp_rating where id=:id

[selectsqlwithdeleted]

[selectsql]
select * from dp_rating where barcode=:tek order by cnt desc

[main]
sourcetablename=DP_RATING
returnfieldname=ID
captionfieldname=CO_SNAME
keyfieldname=ID
ViewID=dp_detail
RootGroupTableName=
ShowCaption=
GetCaption=
GroupSelect=0
foldergroup=
initfolder_id=
dataset=1
InitTMSGroup_id=0
folders_visible=0
Canfloating=0
hidetoppanel=0
ActivateDictAction=2
folderscaption=

[cfSelect]
selectfieldexpression=
AllwaysPartial=1

[block_hl]
fieldname=
column=
color1=128
color2=32768

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=1
bottomdock_size=50
rightdock_units=0
rightdock_size=0

[child_1]
caption= 
wdict=DP_BC_CHECK
oninit=tek=name_id
afterscroll=tek=name_id
afterupd=
afterdatasetopen=tek=sname
defaultdocksite=none
ShortCut=

', NULL, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, ' -  ', NULL, 'DP_BC_CHECK                    ', 1, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]

[deletesql]

[refreshsql]
select id, (select svalue from vals v where v.id=name_id) as sname from wares w where id=:id

[selectsqlwithdeleted]

[selectsql]
select min(id) as id, (select svalue from vals v where v.id=name_id) as sname from wares w where w.barcode=:tek group by name_id

[main]
sourcetablename=WARES
returnfieldname=ID
captionfieldname=SNAME
keyfieldname=ID
ViewID=DP_BC_CHECK
RootGroupTableName=
ShowCaption=
GetCaption=
GroupSelect=0
foldergroup=
initfolder_id=
dataset=1
InitTMSGroup_id=0
folders_visible=0
Canfloating=0
hidetoppanel=1
ActivateDictAction=0
folderscaption=

[cfSelect]
selectfieldexpression=SNAME
AllwaysPartial=1

[block_hl]
fieldname=
column=
color1=128
color2=32768

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=0
bottomdock_size=0
rightdock_units=0
rightdock_size=0

', NULL, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, ' -  ', NULL, 'DP_FULL_LIST                   ', 1, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]

[deletesql]

[refreshsql]
select * from dp_rating where id=:id

[selectsqlwithdeleted]

[selectsql]
select * from dp_rating order by sname, cnt

[main]
sourcetablename=DP_RATING
returnfieldname=ID
captionfieldname=SNAME
keyfieldname=ID
ViewID=DP_FULL_LIST
RootGroupTableName=
ShowCaption=
GetCaption=
GroupSelect=0
foldergroup=
initfolder_id=
dataset=0
InitTMSGroup_id=0
folders_visible=0
Canfloating=0
hidetoppanel=0
ActivateDictAction=0
folderscaption=

[cfSelect]
selectfieldexpression=SNAME||name_id||co_sname||co_name_id
AllwaysPartial=1

[block_hl]
fieldname=
column=
color1=128
color2=32768

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=0
bottomdock_size=0
rightdock_units=0
rightdock_size=0

', NULL, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, '', ' ', 'DP_LTEST                       ', 1, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]

[deletesql]

[refreshsql]
select * from warebase where part_id=:part_id

[selectsqlwithdeleted]

[selectsql]
select * from warebase order by sname

[main]
sourcetablename=WAREBASE
returnfieldname=PART_ID
captionfieldname=SNAME
keyfieldname=PART_ID
ViewID=DP_WB_TEST
RootGroupTableName=
ShowCaption=
GetCaption=
GroupSelect=0
foldergroup=
initfolder_id=
dataset=1
InitTMSGroup_id=0
folders_visible=0
Canfloating=0
hidetoppanel=0
ActivateDictAction=0

[cfSelect]
selectfieldexpression=part_id || sname || ware_id || bcode_izg
AllwaysPartial=1

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=0
bottomdock_size=0
rightdock_units=1
rightdock_size=60

[child_1]
caption= 
wdict=DP_PR_DP_GETPART
oninit=tek_id=part_id
afterscroll=tek_id=part_id
afterupd=
defaultdocksite=right
ShortCut=', 4, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, '    ', '    ', 'DP_NAMELINKS                   ', 1, '2018-09-07 16:14:29', '[insertsql]
insert into DP_NAMELINKS (position_uuid,name_key,D$UUID) values (UUID_TO_CHAR(GEN_UUID()),'''',:D$UUID)

[deletesql_selected]

[deletesql]

[refreshsql]
select * from DP_NAMELINKS where d$uuid=:d$uuid

[selectsqlwithdeleted]

[selectsql]
select * from DP_NAMELINKS order by NAME_KEY,a1,a2,d$uuid

[main]
sourcetablename=DP_NAMELINKS
returnfieldname=POSITION_UUID
captionfieldname=NAME_KEY
keyfieldname=D$UUID
ViewID=DP_NAMELINKS
RootGroupTableName=
ShowCaption=  
GetCaption=:form_caption:
GroupSelect=0
foldergroup=
initfolder_id=
dataset=0
InitTMSGroup_id=
folders_visible=0
Canfloating=0
hidetoppanel=0
ActivateDictAction=0

[cfSelect]
selectfieldexpression=NAME_KEY || '' '' || coalesce(a1,'''') ||'' '' || coalesce(a2,'''') ||'' '' || coalesce(a3,'''') ||'' '' || coalesce(a4,'''') ||'' ''
AllwaysPartial=1

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=8
left=0
Top=0
Width=650
Height=350
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=0
bottomdock_size=0
rightdock_units=0
rightdock_size=0

[editfields]
NAME_KEY=default
POSITION_UUID=default
A1=default
A2=default
A3=default
A4=default
X1=default
X2=default

[addfields]
NAME_KEY=default
D$UUID=select UUID_TO_CHAR(GEN_UUID()) from rdb$database

', NULL, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, 'DP_TEST_PROC', 'DP_TEST_PROC', 'DP_PR_DP_GETPART               ', 1, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]

[deletesql]
update DP_GRATING set actual=0 where co_position_uuid=:co_position_uuid
and position_uuid=:position_uuid

[refreshsql]

[selectsqlwithdeleted]

[selectsql]
select  distinct wb.*, p.cnt, p.label,p.position_uuid,p.co_position_uuid from PR_DP_GETPART(:tek_id) p left join warebase wb on p.co_part_id=wb.part_id

[main]
sourcetablename=WAREBASE
returnfieldname=PART_ID
captionfieldname=SNAME
keyfieldname=PART_ID
ViewID=DP_PR_DP_GETPART
RootGroupTableName=
ShowCaption= .
GetCaption= ,
GroupSelect=0
foldergroup=
initfolder_id=
dataset=1
InitTMSGroup_id=-801
folders_visible=0
Canfloating=0
hidetoppanel=1
ActivateDictAction=0

[cfSelect]
selectfieldexpression=SNAME
AllwaysPartial=1

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=0
bottomdock_size=0
rightdock_units=0
rightdock_size=0

', NULL, NULL);
INSERT INTO SP$WDICTS (ID, PARENT_ID, CAPTION, DESCRIPTION, SID, STATUS, INSERTDT, INI, SORTING, FRAMECLASS)
               VALUES ((select max(w.id)+1 from sp$wdicts w), 0, 'WB_SEL_LIST', 'WB_SEL_LIST', 'DP_WB_SEL_LIST                 ', 1, '2018-09-07 16:14:29', '[insertsql]

[deletesql_selected]

[deletesql]

[refreshsql]
select * from warebase where part_id=:part_id

[selectsqlwithdeleted]

[selectsql]
select * from warebase order by sname

[main]
sourcetablename=WAREBASE
returnfieldname=PART_ID
captionfieldname=SNAME
keyfieldname=PART_ID
ViewID=DP_WB_SELS
RootGroupTableName=
ShowCaption=:form_caption: !
GetCaption=:form_caption:
GroupSelect=0
foldergroup=
initfolder_id=
dataset=1
InitTMSGroup_id=0
folders_visible=0
Canfloating=0
hidetoppanel=0
ActivateDictAction=0

[cfSelect]
selectfieldexpression=part_id || sname || ware_id || bcode_izg
AllwaysPartial=1

[form_show]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[form_get]
position=1
left=0
Top=0
Width=0
Height=0
MaxWidth=0
MaxHeight=0
MinWidth=0
MinHeight=0

[childs]
bottomdock_units=0
bottomdock_size=0
rightdock_units=0
rightdock_size=0

', NULL, NULL);

COMMIT WORK;


SET TERM ^ ;

create or alter procedure PR_DP_GETNAME_RULE (
    SNAME type of DM_TEXT)
returns (
    NAME_RULE type of DM_UUID)
as
declare variable ITEM type of DM_TEXT;
declare variable A1 type of DM_TEXT;
declare variable A2 type of DM_TEXT;
declare variable A3 type of DM_TEXT;
declare variable A4 type of DM_TEXT;
declare variable X1 type of DM_TEXT;
declare variable X2 type of DM_TEXT;
begin
  SNAME=upper(SNAME);
  for select ITEM from UTPR_SPLIT(:sname,' ') into :item do
  begin
    name_rule=null; a1=''; a2=''; a3=''; a4=''; x1=''; x2='';
    for select position_uuid, coalesce(upper(a1),''),coalesce(upper(a2),''),coalesce(upper(a3),''),coalesce(upper(a4),''),coalesce(upper(x1),''),coalesce(upper(x2),'') from DP_NAMELINKS
     where NAME_KEY=:item or (NAME_KEY='')  into :name_rule, :a1,:a2,:a3,:a4,:x1,:x2 do
    if (name_rule is not null) then
    begin
      if (
          ((sname not containing x1) or (x1='')) and ((sname not containing x2) or (x2='')) and (sname containing a1) and (sname containing a2) and (sname containing a3) and (sname containing a4)
         )
       then
       begin
         suspend;
         exit;
         break;
       end 
    end 
  end 
end^

SET TERM ; ^

/* Following GRANT statements are generated automatically */

GRANT EXECUTE ON PROCEDURE UTPR_SPLIT TO PROCEDURE PR_DP_GETNAME_RULE;
GRANT SELECT ON DP_NAMELINKS TO PROCEDURE PR_DP_GETNAME_RULE;

/* Existing privileges on this procedure */

GRANT EXECUTE ON PROCEDURE PR_DP_GETNAME_RULE TO PROCEDURE PR_DP_GETPART;
GRANT EXECUTE ON PROCEDURE PR_DP_GETNAME_RULE TO SYSDBA;

SET TERM ^ ;

create or alter procedure PR_DP_GETPART (
    PART_ID type of DM_ID,
    NAME_RULE type of DM_UUID = null,
    WARE_ID type of DM_UUID = null,
    NAME_ID type of DM_UUID = null,
    BC_IZG type of DM_TEXT = null,
    BARCODE type of DM_TEXT = null,
    BARCODE1 type of DM_TEXT = null,
    GROUP_ID type of DM_ID = null)
returns (
    CO_POSITION_UUID type of DM_UUID,
    SNAME type of DM_TEXT,
    CNT DM_ID,
    CO_PART_ID type of DM_ID,
    CO_WARE_ID type of DM_UUID,
    CO_BARCODE type of DM_TEXT,
    CO_NAME_ID type of DM_UUID,
    CO_GROUP_ID type of DM_ID,
    CO_NAME_RULE type of DM_UUID,
    LABEL type of DM_TEXT,
    POSITION_UUID DM_UUID_NULL)
as
declare variable W_ID type of DM_UUID;
declare variable ITEM type of DM_TEXT;
declare variable A1 type of DM_TEXT;
declare variable A2 type of DM_TEXT;
declare variable A3 type of DM_TEXT;
declare variable A4 type of DM_TEXT;
declare variable X1 type of DM_TEXT;
declare variable X2 type of DM_TEXT;
begin
  if ((ware_id is null) or (name_id is null) or (barcode is null))  then
    select w.id, w.name_id, w.barcode, p.barcode, p.barcode1,w.sname from parts p left join wares w on p.ware_id=w.id where p.id=:part_id into ware_id, name_id, bc_izg, barcode, barcode1,:sname;
  --  
  for select position_uuid from dp_gbclinks where barcode in (:bc_izg, :barcode,:barcode1) or (sname = :sname)  into :position_uuid do
  begin
    for select co_position_uuid, cnt from DP_GRATING where position_uuid=:position_uuid and actual=1 into co_position_uuid, cnt do
    begin
      for select barcode, sname from dp_gbclinks where position_uuid=:co_position_uuid into :barcode, sname do
      begin
        for select sname, part_id from warebase wb where (wb.bcode_izg=:barcode) or (wb.sname=:sname)  into sname, co_part_id do -- or (wb.barcode=:barcode) or (wb.barcode1=:barcode)
        begin
          label='';
          suspend;
        end
      end
    end 
  end
  POSITION_UUID=null;CO_POSITION_UUID=null;
--  exit;
/*    -    */
 /* for select group_id from group_detail where (GROUPTABLE='PARTS' and GROUPTABLE_ID=cast(:part_id as dm_text))
                                     or (GROUPTABLE='PARTS.NAME_ID' and GROUPTABLE_ID=:name_id) into group_id do
  begin
    CNT=null;CO_POSITION_UUID=null;CO_PART_ID=null;CO_WARE_ID=null;CO_BARCODE=null;CO_NAME_ID=null;CO_GROUP_ID=null;
    for select CNT,CO_POSITION_UUID,CO_PART_ID,CO_WARE_ID,CO_BARCODE,CO_NAME_ID,CO_GROUP_ID from DP_LRATING where GROUP_ID=:group_id
    --order by cnt desc
    into CNT,CO_POSITION_UUID,CO_PART_ID,CO_WARE_ID,CO_BARCODE,CO_NAME_ID,CO_GROUP_ID do
    begin
--     
      if (CO_POSITION_UUID is not null) then
      begin
        for select barcode, sname from dp_gbclinks where position_uuid=:co_position_uuid into :barcode, sname do
        begin
          for select sname, part_id from warebase wb where (wb.bcode_izg=:barcode)
           --or (wb.barcode=:barcode) or (wb.barcode1=:barcode)
          into sname, co_part_id do
          begin
            label='STAT by GROUP';
            suspend;
          end
        end
      end
 --, ,    warebase...
      for select sname, part_id from warebase wb where (part_id=:co_part_id) or (ware_id=:co_ware_id) or (bcode_izg=:co_barcode) or (name_id=:co_name_id) or (:co_group_id is not null and wb.mmbsh containing ' '||:co_group_id||'=')  into sname, co_part_id do
      begin
        if (co_part_id is not null) then label='PART by GROUP';
        else if (co_ware_id is not null) then label='WARE by GROUP';
        else if (co_barcode is not null) then label='BC by GROUP';
        else if (co_name_id is not null) then label='NAME by GROUP';
        else if (co_group_id is not null) then label='GROUP by GROUP';
        else label='N/A  by GROUP';
        suspend;
      end 
    end
  end     */
/* " */

/*    */
  name_rule=null;
  select NAME_RULE from PR_DP_GETNAME_RULE((select svalue from vals where id=:name_id)) into :name_rule;
--  select first 1 t.position_uuid from UTPR_SPLIT((select svalue from vals where id=:name_id),' ') pr left join DP_NAMELINKS t on upper(pr.item)=t.name_key where t.name_key is not null into :name_rule;
/**/
/*   */
    for select CNT,CO_POSITION_UUID,CO_PART_ID,CO_WARE_ID,CO_BARCODE,CO_NAME_ID,CO_GROUP_ID,CO_NAME_RULE from DP_LRATING where
          (POSITION_UUID is null and PART_ID=:part_id and WARE_ID is null and BARCODE is null and NAME_ID is null and GROUP_ID is null and NAME_RULE is null) or
          (POSITION_UUID is null and PART_ID is null and WARE_ID=:ware_id and BARCODE is null and NAME_ID is null and GROUP_ID is null and NAME_RULE is null) or
          (POSITION_UUID is null and PART_ID is null and WARE_ID is null and BARCODE=:bc_izg and NAME_ID is null and GROUP_ID is null and NAME_RULE is null) or
          (POSITION_UUID is null and PART_ID is null and WARE_ID is null and BARCODE is null and NAME_ID=:name_id and GROUP_ID is null and NAME_RULE is null) or
          (POSITION_UUID is null and PART_ID is null and WARE_ID is null and BARCODE is null and NAME_ID is null and GROUP_ID is null and NAME_RULE=:name_rule)
     into CNT,CO_POSITION_UUID,CO_PART_ID,CO_WARE_ID,CO_BARCODE,CO_NAME_ID,CO_GROUP_ID, CO_NAME_RULE do
    begin
/*        */
      if (CO_NAME_RULE is not null) then
      begin
--        a1=''; a2=''; a3=''; a4=''; x1=''; x2='';
        for select name_key, coalesce(upper(a1),''),coalesce(upper(a2),''),coalesce(upper(a3),''),coalesce(upper(a4),''),coalesce(upper(x1),''),coalesce(upper(x2),'') from dp_namelinks where position_uuid=:co_name_rule into :item, :a1,:a2,:a3,:a4,:x1,:x2 do
        begin
          for select sname, part_id from warebase wb where upper(sname) containing :item
          and ((upper(sname) not containing :x1) or (:x1='')) and ((upper(sname) not containing :x2) or (:x2='')) and (upper(sname) containing :a1) and (upper(sname) containing :a2) and (upper(sname) containing :a3) and (upper(sname) containing :a4)
           into sname, co_part_id do
--          for select sname, part_id from warebase wb where upper(sname) containing :item into sname, co_part_id do
          begin
            label=' ';
            suspend;
            co_part_id=null;
          end
        end
      end 
/**/
/*      */
      if (CO_POSITION_UUID is not null) then
      begin
        for select barcode, sname from dp_gbclinks where position_uuid=:co_position_uuid into :barcode, sname do
        begin
          for select sname, part_id from warebase wb where (wb.bcode_izg=:barcode)/* or (wb.barcode=:barcode) or (wb.barcode1=:barcode)*/ into sname, co_part_id do
          begin
            label='G_ANY by ANY';
            suspend;
            co_part_id=null;
          end
        end
      end
/**/
/*, ,    warebase...*/
      for select sname, part_id from warebase wb where (part_id=:co_part_id) or (ware_id=:co_ware_id) or (bcode_izg=:co_barcode) or (name_id=:co_name_id) or (:co_group_id is not null and wb.mmbsh containing ' '||:co_group_id||'=')  into sname, co_part_id do
      begin
        label='ANY by ANY';
        suspend;
      end 
/**/
    end 
/**/
end^

SET TERM ; ^

/* Following GRANT statements are generated automatically */

GRANT SELECT ON PARTS TO PROCEDURE PR_DP_GETPART;
GRANT SELECT ON WARES TO PROCEDURE PR_DP_GETPART;
GRANT SELECT ON DP_GBCLINKS TO PROCEDURE PR_DP_GETPART;
GRANT SELECT ON DP_GRATING TO PROCEDURE PR_DP_GETPART;
GRANT SELECT ON WAREBASE TO PROCEDURE PR_DP_GETPART;
GRANT EXECUTE ON PROCEDURE PR_DP_GETNAME_RULE TO PROCEDURE PR_DP_GETPART;
GRANT SELECT ON VALS TO PROCEDURE PR_DP_GETPART;
GRANT SELECT ON DP_LRATING TO PROCEDURE PR_DP_GETPART;
GRANT SELECT ON DP_NAMELINKS TO PROCEDURE PR_DP_GETPART;

/* Existing privileges on this procedure */

GRANT EXECUTE ON PROCEDURE PR_DP_GETPART TO PROCEDURE PR_DOC_ACCOMPANY;
GRANT EXECUTE ON PROCEDURE PR_DP_GETPART TO SYSDBA;


SET TERM ^ ;

create or alter procedure PR_DOC_ACCOMPANY (
    LINK_ID DM_ID)
returns (
    PART_ID type of DM_ID,
    ACCOMP_ID type of DM_ID,
    TPART_ID DM_ID,
    DD_ID DM_ID_NULL)
as
begin
  for select DDA.PART_ID,dda.ID
      from DOCS D
      join DOC_DETAIL_ACTIVE DDA on D.ID = DDA.DOC_ID
      where D.LINK_ID = :LINK_ID and
            D.STATUS = 0 and
            D.DOC_TYPE in (3, 9)
      into :TPART_ID,:dd_id
  do
  begin
    for select distinct co_part_id, cnt from PR_DP_GETPART(:tpart_id) into :part_id, :accomp_id do
    begin
      suspend;
    end 
  end
end^

SET TERM ; ^

/* Following GRANT statements are generated automatically */

GRANT SELECT ON DOCS TO PROCEDURE PR_DOC_ACCOMPANY;
GRANT SELECT ON DOC_DETAIL_ACTIVE TO PROCEDURE PR_DOC_ACCOMPANY;
GRANT EXECUTE ON PROCEDURE PR_DP_GETPART TO PROCEDURE PR_DOC_ACCOMPANY;

/* Existing privileges on this procedure */

GRANT EXECUTE ON PROCEDURE PR_DOC_ACCOMPANY TO SYSDBA;